function _assert_this_initialized(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
}
function _call_super(_this, derived, args) {
    derived = _get_prototype_of(derived);
    return _possible_constructor_return(_this, _is_native_reflect_construct() ? Reflect.construct(derived, args || [], _get_prototype_of(_this).constructor) : derived.apply(_this, args));
}
function _class_call_check(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _create_class(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _get(target, property, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.get) {
        _get = Reflect.get;
    } else {
        _get = function get(target, property, receiver) {
            var base = _super_prop_base(target, property);
            if (!base) return;
            var desc = Object.getOwnPropertyDescriptor(base, property);
            if (desc.get) {
                return desc.get.call(receiver || target);
            }
            return desc.value;
        };
    }
    return _get(target, property, receiver || target);
}
function _get_prototype_of(o) {
    _get_prototype_of = Object.setPrototypeOf ? Object.getPrototypeOf : function getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _get_prototype_of(o);
}
function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) _set_prototype_of(subClass, superClass);
}
function _possible_constructor_return(self, call) {
    if (call && (_type_of(call) === "object" || typeof call === "function")) {
        return call;
    }
    return _assert_this_initialized(self);
}
function _set_prototype_of(o, p) {
    _set_prototype_of = Object.setPrototypeOf || function setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
    };
    return _set_prototype_of(o, p);
}
function _super_prop_base(object, property) {
    while(!Object.prototype.hasOwnProperty.call(object, property)){
        object = _get_prototype_of(object);
        if (object === null) break;
    }
    return object;
}
function _type_of(obj) {
    "@swc/helpers - typeof";
    return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj;
}
function _is_native_reflect_construct() {
    try {
        var result = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
    } catch (_) {}
    return (_is_native_reflect_construct = function() {
        return !!result;
    })();
}
import { accessor, constant } from "../utils/index.js";
import Shape from "./Shape.js";
var Rect = /*#__PURE__*/ function(Shape) {
    "use strict";
    _inherits(Rect, Shape);
    function Rect() {
        _class_call_check(this, Rect);
        var _this;
        _this = _call_super(this, Rect, [
            "rect"
        ]), _define_property(_this, "_height", void 0), _define_property(_this, "_width", void 0);
        _this._height = accessor("height");
        _this._labelBounds = function(_d, _i, s) {
            return {
                width: s.width,
                height: s.height,
                x: -s.width / 2,
                y: -s.height / 2
            };
        };
        _this._name = "Rect";
        _this._width = accessor("width");
        return _this;
    }
    _create_class(Rect, [
        {
            /**
      Draws the rectangles.
    @param callback Optional callback invoked after rendering completes.
*/ key: "render",
            value: function render(callback) {
                _get(_get_prototype_of(Rect.prototype), "render", this).call(this, callback);
                var enter = this._enter.attr("width", 0).attr("height", 0).attr("x", 0).attr("y", 0).call(this._applyStyle.bind(this));
                var update = this._update;
                if (this._duration) {
                    enter = enter.transition(this._transition);
                    update = update.transition(this._transition);
                    this._exit.transition(this._transition).attr("width", 0).attr("height", 0).attr("x", 0).attr("y", 0);
                }
                enter.call(this._applyPosition.bind(this));
                update.call(this._applyStyle.bind(this)).call(this._applyPosition.bind(this));
                return this;
            }
        },
        {
            /**
      Given a specific data point and index, returns the aesthetic properties of the shape.
      @param data point*
      @param index @private
*/ key: "_aes",
            value: function _aes(d, i) {
                return {
                    width: this._width(d, i),
                    height: this._height(d, i)
                };
            }
        },
        {
            /**
      Provides the default positioning to the <rect> elements.
      @param elem @private
*/ key: "_applyPosition",
            value: function _applyPosition(elem) {
                var _this = this;
                // eslint-disable-next-line @typescript-eslint/no-explicit-any
                elem.attr("width", function(d, i) {
                    return _this._width(d, i);
                }).attr("height", function(d, i) {
                    return _this._height(d, i);
                }).attr("x", function(d, i) {
                    return -_this._width(d, i) / 2;
                }).attr("y", function(d, i) {
                    return -_this._height(d, i) / 2;
                });
            }
        },
        {
            key: "height",
            value: function height(_) {
                return arguments.length ? (this._height = typeof _ === "function" ? _ : constant(_), this) : this._height;
            }
        },
        {
            key: "width",
            value: function width(_) {
                return arguments.length ? (this._width = typeof _ === "function" ? _ : constant(_), this) : this._width;
            }
        }
    ]);
    return Rect;
}(Shape);
/**
    Creates SVG rectangles based on an array of data. See [this example](https://d3plus.org/examples/d3plus-shape/getting-started/) for help getting started using the rectangle generator.
*/ export { Rect as default };
